#ifdef ACQUIDATA_EXPORTS
#define ACQUIDATA_API __declspec(dllexport)
#else
#define ACQUIDATA_API __declspec(dllimport)
#endif

#include "Const.h"
#include "Types.h"

// initExports (void);
// Sert  initialiser les donnes exportables du DLL.
// Ne doit tre appele que par le module d'acquisition
// lui-mme
ACQUIDATA_API void __stdcall initExports (void);

// devicesFull (void);
// Retourne VRAI si le DLL a atteint sa capacit en terme
// de nombre de senseurs supports, FAUX s'il peut encore
// en accepter d'autres.
ACQUIDATA_API bool __stdcall devicesFull (void);

// addDevice (const char*, const tData);
// Prend le nom d'un senseur et une valeur par dfaut pour
// en initialiser les donnes, et retourne l'index auquel
// ce senseur a t affect dans les tables du module (ou -1
// s'il n'a pu tre affect).
// Le tableau doit avoir une capacit de MAX_DEVICE_NAMELEN octets.
ACQUIDATA_API int  __stdcall addDevice (const char*,
                                        const tData);

// getDevice (const int, char*, tData&);
// Prend l'index d'un senseur (premier paramtre) et donne
// son nom (second paramtre) et le type de donnes qu'il
// produit (troisime paramtre). Elle retourne VRAI si
// l'opration a fonctionn, FAUX dans le cas d'une erreur.
// Le nom doit tre un tableau de caractres d'une capacit de
// MAX_DEVICE_NAMELEN octets.
ACQUIDATA_API bool __stdcall getDevice (const int, char*, tType&);

// removeDevices (void);
// Dsenregistre tous les senseurs.
ACQUIDATA_API void __stdcall removeDevices (void);

// peekCommand (void);
// Retourne la valeur entire indiquant la prochaine commande
//  traiter par le module d'acquisition, sans l'enlever de la
// file d'attente o elle se trouve.
ACQUIDATA_API int __stdcall peekCommand (void);

// getCommand (void);
// Retourne la valeur entire indiquant la prochaine commande
//  traiter par le module d'acquisition, et l'enlve de la
// file d'attente o elle se trouve.
ACQUIDATA_API int __stdcall getCommand (void);

// addCommand (const int);
// Ajoute la valeur passe en paramtre  la fin de la file
// d'attente de commandes  traiter par le module d'acquisition.
ACQUIDATA_API void __stdcall addCommand (const int);

// getNbAcqui (void);
// Retourne le nombre de modules d'acquisition connects. Ce
// nombre devrait tre 0 ou 1.
ACQUIDATA_API int __stdcall getNbAcqui (void);

// ConnectAcqui (void);
// Connecte un module d'acquisition et effectue certaines petites
// initialisations appropries. Ceci devrait exclure tout autre
// module d'acquisition jusqu' ce que le module connect ne se
// soit dconnect.
ACQUIDATA_API void __stdcall ConnectAcqui (void);

// DisonnectAcqui (void);
// Dconnecte un module d'acquisition. Peut tre appel par un
// autre module d'acquisition que celui dj connect, ce qui
// peut tre utile si ce dernier a plant :)
ACQUIDATA_API void __stdcall DisconnectAcqui (void);

// getNbDevices (void);
// Retourne le nombre de senseurs enregistrs au module.
ACQUIDATA_API int __stdcall getNbDevices (void);

// RegisterCommand (const char*);
// Enregistre par son nom une commande qui peut tre passe au
// module d'acquisition, et retourne l'entier qui l'identifiera.
// Le tableau doit avoir une capacit de MAX_COMMAND_NAMELEN octets.
ACQUIDATA_API int __stdcall RegisterCommand (const char*);

// UnregisterCommands (void);
// Dsenregistre toutes les commandes du module d'acquisition.
ACQUIDATA_API void __stdcall UnregisterCommands (void);

// getNbCommands (void);
// Retourne le nombre de commandes enregistres par le module
// d'acquisition.
ACQUIDATA_API int __stdcall getNbCommands (void);

// CommandsFull (void);
// Retourne VRAI si la table des commandes enregistres est
// pleine, FAUX sinon.
ACQUIDATA_API bool __stdcall CommandsFull (void);

// getCommandName (const int, char*);
// Dpose le nom de la commande indique par l'index (premier
// paramtre) dans le tableau de caractres (second paramtre).
// Le tableau doit avoir une capacit de MAX_COMMAND_NAMELEN octets.
ACQUIDATA_API void __stdcall getCommandName (const int, char*);

// setRawData (const int, const char*);
// Permet  un senseur identifi par le premier paramtre de
// soumettre ses donnes crues sous la forme d'un tableau
// d'octets (second paramtre).
// Le tableau doit avoir une capacit de MAX_RAWDATA_SIZE octets.
ACQUIDATA_API void __stdcall setRawData (const int, const char*);

// getRawData (const int, char*);
// Permet de dposer les donnes crues du senseur identifi
// par le premier paramtre dans un tableau d'octets (second
// paramtre).
// Le tableau doit avoir une capacit de MAX_RAWDATA_SIZE octets.
ACQUIDATA_API void __stdcall getRawData (const int, char*);

// setRawDataInfo (const int, const int, const int);
// Pour le senseur  l'index donn par le premier paramtre,
// cette procdure considre le deuxime paramtre comme
// tant le nombre de rafrachissements des donnes qu'a
// subi ce senseur, le troisime paramtre le taille en octets
// du dernier rafrachissement.
ACQUIDATA_API void __stdcall setRawDataInfo (const int, const int, const int);

// getRawDataInfo (const int, int&, int&);
// Pour le senseur  l'index donn par le premier paramtre,
// cette procdure dpose dans le deuxime paramtre une valeur
// indiquant le nombre de rafrachissements des donnes qu'a
// subi ce senseur, et dans le troisime paramtre le taille
// en octets du dernier rafrachissement.
ACQUIDATA_API void __stdcall getRawDataInfo (const int, int&, int&);
